#include <stdio.h>
#include <errno.h>
#include <glob.h>
#include <unistd.h>

int main(int argc, char **argv)
{
	int i = 0, j = 0;
	// noescape = FALSE will be the default case
	int flags = 0;
	glob_t results;
	int rv;

	// Define list of globs to obtain CWD filename results here
	char globs[3][10] = { { "\\*" }, { "\\?" }, { "\\[hello\\]" } };

	for(i = 0; i < 3; i++) {
		flags = 0; // noescape = FALSE case (treat '\' as escape character)
		flags |= (i > 1 ? GLOB_APPEND : 0);
		rv = glob(globs[i], flags, NULL, & results);
		fprintf(stdout, "\n- noescape = FALSE:\n\tC glob: \'%s\'", globs[i]);
		fprintf(stdout, "\n\tList of files in CWD matching C glob:\n\t");
		if (rv != 0) {
			if (rv == GLOB_NOMATCH)
				fprintf(stdout, "No match for pattern \'%s\'\n", globs[i]);
		}
		else {
			for (j = 0; j < results.gl_pathc; j++) 
				fprintf(stdout, " \'%s\'", results.gl_pathv[j]);

			globfree(& results);
		
		}
		
		flags = GLOB_NOESCAPE; // noescape = TRUE case (treat '\' as literal)
		flags |= (i > 1 ? GLOB_APPEND : 0);
		rv = glob(globs[i], flags, NULL, & results);
		fprintf(stdout, "\n- noescape = TRUE:\n\tC glob: \'%s\'", globs[i]);
		fprintf(stdout, "\n\tList of files in CWD matching C glob:\n\t");
		if (rv != 0) {
			if (rv == GLOB_NOMATCH)
				fprintf(stdout, "No match for pattern \'%s\'\n", globs[i]);
		}
		else {
			for (j = 0; j < results.gl_pathc; j++)
				fprintf(stdout, " \'%s\'", results.gl_pathv[j]);

			globfree(& results);

		}
	}

	return 0;
}
